<?php 
// +----------------------------------------------------------------------
// | OneKeyAdmin [ Believe that you can do better ]
// +----------------------------------------------------------------------
// | Copyright (c) 2020-2023 http://onekeyadmin.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: MUKE <513038996@qq.com>
// +----------------------------------------------------------------------
declare (strict_types = 1);

namespace app\admin\middleware;

use app\admin\model\Admin;
use app\admin\model\AdminMenu;
use app\admin\model\AdminToken;
/**
 * 权限检测
 */
class AuthCheck
{
    /**
     * 不需要检查的类
     * @var noVerification
     */
    protected $ignoreCheckClass = [
        'login','api'
    ];
    
    public function handle($request, \Closure $next)
    {
        if (! in_array($request->class, $this->ignoreCheckClass)) {
            // 权限菜单
            $where = [];
            $group_role = is_array($request->userInfo->group_role) ? implode(',', $request->userInfo->group_role) : $request->userInfo->group_role;
            if ($group_role !== "*") {
                $where[] = ['id', 'in', $group_role];
            }
            $request->menu = array_sort(AdminMenu::where($where)->select()->toArray(), 'sort');
            // 权限检查
            $request->authorityList  = array_column($request->menu, 'path');
            $request->authorityIndex = array_search($request->authorityPath, $request->authorityList);
            if ($request->path !== 'index/index') {
                if ($request->authorityIndex === false) {
                    return $request->isPost() ? json(['status' => 'error', 'message' => '当前权限不足~']) : abort(403);
                }
            }
        }
        // 下一步
        return $next($request);
    }
}