<?php
// +----------------------------------------------------------------------
// | OneKeyAdmin [ Believe that you can do better ]
// +----------------------------------------------------------------------
// | Copyright (c) 2020-2023 http://onekeyadmin.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: MUKE <513038996@qq.com>
// +----------------------------------------------------------------------
namespace app\admin\model;

use think\Model;

class Admin extends Model
{
    // 关联模型
    public function group()
    {
        return $this->hasOne(AdminGroup::class, 'id', 'group_id')->bind([
            'group_title' => 'title', 
            'group_role'  => 'role'
        ]);
    }

    // 搜索器
    public function searchKeywordAttr($query, $value, $array)
    {
    	if (! empty($value)) {
	        $query->where("nickname|email|account|id",'like', '%' . $value . '%');
	    }
    }

    public function searchStatusAttr($query, $value, $array)
    {
        if ($value !== '') {
            $query->where("status", '=', $value);
        }
    }
    
    public function searchDateAttr($query, $value, $array)
    {
        if (! empty($value)) { 
            $query->whereBetweenTime('create_time', $value[0], $value[1]);
        }
    }

    // 获取器
    public function getPasswordAttr($value, $array)
    {
        return '';
    }
    
    public function getDisabledAttr($value, $array)
    {
        if ($array['group_id'] === 1) {
            return true;
        }
    }
    
    // 修改器
    public function setPasswordAttr($value, $array)
    {
        if (! empty($value)) {
            $password = password_hash($value, PASSWORD_BCRYPT, ['cost' => 12]); 
            $this->set('password', $password);
        }
    }
}