<?php
// +----------------------------------------------------------------------
// | OneKeyAdmin [ Believe that you can do better ]
// +----------------------------------------------------------------------
// | Copyright (c) 2020-2023 http://onekeyadmin.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: MUKE <513038996@qq.com>
// +----------------------------------------------------------------------
namespace app\admin\model;

use think\Model;

class AdminLog extends Model
{
    // 关联模型
    public function admin()
    {
        return $this->hasOne(Admin::class, 'id', 'admin_id')->bind([
            'admin_account' => 'account',
            'admin_email'   => 'email',
            'admin_cover'   => 'cover',
        ]);
    }

    // 搜索器
    public function searchKeywordAttr($query, $value)
    {
    	if (! empty($value)) {
	        $query->where("title|path|ip|post","like", "%" . $value . "%");
	    }
    }

    public function searchDateAttr($query, $value)
    {
        if (! empty($value)) {
            $query->where("create_time", 'between', $value);
        }
    }
    
    // 修改器
    public function setPostAttr($array, $value)
    {
    	return json_encode($value, JSON_UNESCAPED_UNICODE);
    }
    
    public function getPostAttr($array, $value)
    {
    	$post = json_decode($value['post'],true);
    	$html = '';
    	foreach ($post['post'] as $key => $val) {
    	    $value = is_array($val) ? json_encode($val, JSON_UNESCAPED_UNICODE) : $val;
    	    $html .= "<div style='width: 400px;overflow: hidden;margin-bottom: 15px'>
    	    <span style='width: 90px;display: inline-block;text-align: left;font-size: 14px;margin-right: 10px;margin-left: 20px;'>{$key}：</span>
    	    <span style='display: inline-block;vertical-align: middle;width: -moz-calc(100% - 130px);width: -webkit-calc(100% - 130px);width: calc(100% - 130px);'>{$value}</span>
    	    </div>";
    	}
    	return $html;
    }
}