<?php
// +----------------------------------------------------------------------
// | OneKeyAdmin [ Believe that you can do better ]
// +----------------------------------------------------------------------
// | Copyright (c) 2020-2023 http://onekeyadmin.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: MUKE <513038996@qq.com>
// +----------------------------------------------------------------------
namespace app\admin\validate;

use think\Validate;

class Admin extends Validate
{
    protected $rule =   [
        'group_id'      => 'require',
        'nickname'      => 'require|min:2|max:40',
        'email'         => 'require|email',
        'account'       => ['require','min' => 5,'max' => 40],
        'password'      => ['min' => 6,'max' => 40],
        'captcha'       => 'require|captcha',
    ];
    protected $message  =   [
        'group_id.require' => '请选择所属角色',
        'nickname.require' => '请输入昵称',
        'nickname.min'     => '昵称长度不能小于2位',
        'nickname.max'     => '昵称长度不能大于40位',
        'email.require'    => '请填写邮箱号',
        'email.email'      => '邮箱号格式错误',
        'account.require'  => '请输入账号',
        'account.min'      => '登录账号长度不能小于5位',
        'account.max'      => '登录账号长度不能大于40位',
        'password.min'     => '登录密码长度不能小于6位',
        'password.max'     => '登录密码长度不能大于40位',
        'captcha.require'  => '请输入验证码',
        'captcha.captcha'  => '验证码错误',
    ];
    protected $scene = [
        'save'          => ['group_id','nickname','email','account','password'],
        'update'        => ['nickname'],
        'password'      => ['email','password','code'],
        'login'         => ['account','password', 'captcha'],
        'code'          => ['email'],
    ];
}