<?php
// +----------------------------------------------------------------------
// | OneKeyAdmin [ Believe that you can do better ]
// +----------------------------------------------------------------------
// | Copyright (c) 2020-2023 http://onekeyadmin.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: MUKE <513038996@qq.com>
// +----------------------------------------------------------------------
namespace app\api\model;

use think\Model;

class User extends Model
{
    // 设置json类型字段
    protected $json = ['field'];

    protected $jsonAssoc = true;
    
    // 获取器
    public function getUrlAttr($value, $array)
    {
        return index_url('user/info', ['id' => $array['id']]);
    }
    
    public function getLoginIpAttr($value, $array)
    {
        return '';
    }
    
    public function getCEmailAttr($value, $array)
    {
        return ! empty($value) ? substr_replace($value,'****',3,4): '';
    }

    public function getCMobileAttr($value, $array)
    {
        return ! empty($value) ? substr_replace($value,'****',3,4) : '';
    }
    
    public function getGroupAttr($value, $array)
    {
        return UserGroup::where('integral', '<=', $array['history_integral'])->order('integral', 'desc')->find();
    }
    
    // 修改器
    public function setPasswordAttr($value, $array)
    {
    	if (! empty($value)) {
    		$password = password_hash($value, PASSWORD_BCRYPT, ['cost' => 12]);	
	        $this->set('password', $password);
    	}
    }
}